{% extends 'atila-vue/html.j2' %}

{% if 'vue_config' not in context %}
  {% set _ = context.update ({'vue_config': {}}) %}
{% endif %}
{% if 'app_config' not in context %}
  {% set _ = context.update ({'app_config': {'use_js_cdn': False}}) %}
{% endif %}

{% if context.vue_config.use_router %}
  {% if '/' in self._TemplateReference__context.name %}
    {% set routes, pathes, router_view_layout = build_routes ('/' + self._TemplateReference__context.name.split ('/')[0], context.vue_config.use_router) %}
  {% else %}
    {% set routes, pathes, router_view_layout = build_routes ('/' + self._TemplateReference__context.name.split ('.')[0], context.vue_config.use_router) %}
  {% endif %}
{% else %}
  {% set routes, pathes, router_view_layout = [], [], None %}
{% endif %}
{% set use_vue_loader = context.vue_config.use_loader or app.debug %}

{% set cdn = [request_context.static ('cdn'), "https://cdn.jsdelivr.net/npm", "https://unpkg.com"][1 if context.app_config.use_js_cdn else 0] %}
{% set _base_scripts = [
  "{}/vue@3.4/dist/vue.{}.js".format (cdn, app.debug and 'global' or 'global.prod'),
  "{}/vuex@4.1/dist/vuex.{}.js".format (cdn, app.debug and 'global' or 'global.prod'),
  "{}/mitt@3.0/dist/mitt.umd.js".format (cdn),
  "{}/axios@1.6/dist/axios.min.js".format (cdn),
] %}

{% if context.vue_config.use_router %}
  {% set _ = _base_scripts.append ("{}/vue-router@4.3/dist/vue-router.{}.js".format (cdn, app.debug and 'global' or 'global.prod')) %}
{% endif %}

{% if use_vue_loader %}
  {% set _ = _base_scripts.append ("{}/vue3-sfc-loader@0.9/dist/vue3-sfc-loader.js".format (cdn)) %}
{% endif %}

{% set _ = _base_scripts.append (request_context.static ('atila-vue/js/backend-vue.js')) %}
{% set _ = _base_scripts.append (request_context.static ('atila-vue/js/frontend-vue.js')) %}

{% macro show_python_context () %}
  <article class='container'>
      <div class="mb-3">
        <code class="text-red-accent-3">This area below is displayed because the current app is running in
          <b class="px-1 text-light bg-red-accent-3">debug mode</b>
          <b class="ml-2 px-1 text-white bg-green-darken-2">{{ 'state.$breakpoint' | vue }}</b>
        </code>
      </div>
      <div class="context">
        <h5>Template Context</h5>
        <ul>
        {% for k, v in context.items () %}
            {% if k.endswith ('_config') %}
              <li class='mb-0'><code>context.{{ k }}: {{ v | escape }}</code></li>
            {% endif %}
        {% endfor %}
        </ul>
      </div>
  </article>
{% endmacro %}

{% macro set_cloak (flag = True) %}
  {{ map_data ('$cloak', flag) }}
{% endmacro %}

{% macro map_data (name, value, container = '', list_size = -1) %}
  {% if not container %}
    <script>assign_state ('{{name}}', {{ value|tojson_with_datetime|replace ("'", "&#39;") }})</script>
  {% else %}
    {% if list_size == -1 %}{{ raise ('map_data error, list_size must be defined if container specified') }}{% endif %}
    <div class="veux-state" data-name="{{ name }}" data-max-size="{{ list_size }}" data-container="{{ container }}" data-default='{{ value|tojson_with_datetime|replace ("'", "&#39;") }}'></div>
    <script>_vuexState.{{ name }} = []</script>
  {% endif %}
{% endmacro%}

{% macro map_state (name, value, container = '', list_size = -1) %}
  {{ map_data (name, value, container, list_size) }}
{% endmacro%}

{% macro map_data_attrs (name, css, length, default = {}) %}
  {{ map_data (name, default, css, length) }}
{% endmacro%}

{% macro map_kwargs (name) %}
  {{ map_data (name, kwargs) }}
{% endmacro %}

{% macro map_text (name, container, type = 'text') %}
  <div class="veux-state" data-name="{{ name }}" data-container="{{ container }}" data-type="{{ type }}"></div>
  <script>_vuexState.{{ name }} = ''</script>
{% endmacro %}

{% macro map_html (name, container) %}
  {{ map_text (name, container, 'html') }}
{% endmacro %}

{% macro map_route (__name__ = '') %}
  {% for k, v in kwargs.items () %}
    {% do kwargs.__setitem__ (k | upper, request_context.urlspec (v)) %}
  {% endfor %}
  {{ map_data ('$urlspecs', kwargs) }}
{% endmacro %}

{% macro component (path, alias = none, _async = True) %}
  {% set url = request_context.static (path) %}
  {% do request_context.push (url) %}
  {% if _async %}
    {{ "'{}': Vue.defineAsyncComponent ( () => loadModule ('{}', options) ),".format (alias or path.split ("/")[-1][:-4], url) }}
  {% else %}
    {{ "'{}': () => loadModule ('{}', options),".format (alias or path.split ("/")[-1][:-4], url) }}
  {% endif %}
{% endmacro %}

{% macro global_component (path, alias = none, _async = True) %}
  {% set url = request_context.static (path) %}
  {% do request_context.push (url) %}
  {% if _async %}
    {{ "app.component ('{}', Vue.defineAsyncComponent ( () => loadModule ('{}', options) ))".format (alias or path.split ("/")[-1][:-4], url) }}
  {% else %}
    {{ "app.component ('{}', () => loadModule ('{}', options) )".format (alias or path.split ("/")[-1][:-4], url) }}
  {% endif %}
{% endmacro %}

{% macro add_component (path, alias = none, _async = True) %}
  {{ component (path, alias, _async) }}
{% endmacro %}

{% macro add_global_component (path, alias = none, _async = True) %}
  {{ global_component (path, alias, _async) }}
{% endmacro %}

{% block head %}
  {{ super () }}
  {% if context.app_config.use_js_cdn %}
    <link rel="preconnect" href="{{ cdn }}">
  {% endif %}
  {% for each in _base_scripts %}
    <link rel="preload" as="script" href="{{ each }}">
  {% endfor %}
{% endblock %}

{% block style %}
   [v-cloak] { display: none !important;}
   #state-map {display: none;}
{% endblock %}

{% block body %}
  <div id="app" v-cloak>
    <transition name="fade" mode="out-in" appear>
      <div v-show='!$cloak'>
      {% block content_head %}{% endblock %}
      {% block content %}
        {% if context.vue_config.use_router %}<app-layout></app-layout>{% endif %}
      {% endblock %}
      {% block content_foot %}{% endblock %}
      </div>
    </transition>
    {% if app.debug %}
    <a title="Debug Output" class="btn text-secondary pt-0 pb-0 px-1" style="z-index: 10000;  position: fixed; bottom: 8px; left: 4px; opacity: 0.1;" @click="show_debug_output=!show_debug_output">
      <i class="bi bi-bug-fill"></i>
    </a>
    <transition name="fade" mode="out-in" appear>
      <div class="debug-context no-print" v-if="show_debug_output">
        {{ show_python_context () }}
        <vuex-state></vuex-state>
      </div>
    </transition>
    {% endif %}
  </div>
{% endblock %}

{% block body_trailer %}
  {{ super () }}
  {% block before_vue_load %}{% endblock %}
  {% for each in _base_scripts %}
    <script src="{{ each }}"></script>
  {% endfor %}

  {% block vue_loaded %}{% endblock %}
  {% block body_trailer_script %}{% endblock %}

  <div id="state-map">
  {{ map_data ('$tmp', {}) }}
  {{ map_data ('$apispecs', get_apispecs ()) }}
  {{ map_data ('$args', request.args) }}
  {{ map_data ('$cloak', False) }}
  {{ map_data ('$traceback', '') }}
  {{ map_data ('$static_url', app.config.STATIC_URL) }}
  {{ map_data ('$media_url', app.config.MEDIA_URL) }}
  {% if app.config.get ('BACKEND') %}{{ map_data ('$backend', app.config.BACKEND) }}{% endif %}
  {{ map_data ('$txnid', '{}@{}'.format (request.gtxid, request.channel.server.worker_ident)) }}
  {% block state_map %}{% endblock %}
  </div>

  {% block scripts %}{% endblock %}

  {% block vuex %}
    <script>
    const { useStore, mapState, mapGetters, mapActions, mapMutations } = Vuex

    const store = Vuex.createStore ({
      state () {
        return {
          ..._vuexState,
          {% block vuex_state %}{% endblock %}
        }
      },
      getters: {
        {% block vuex_getters %}{% endblock %}
      },
      mutations: {
        _clear_credential (state) {
          state.$uid = null
          state.$grp = null
          state.$breakpoint = 'na'
          state.$claims = null
          state.$authentificated = true
          state.$ls.remove ('refresh_token')
          state.$ls.remove ('access_token')
          delete axios.defaults.headers.common ["Authorization"]
          state.$has_credential = false
        },

        _save_credential (state, payload) {
          const { uid, grp, access_token, refresh_token } = payload
          axios.defaults.headers.common ["Authorization"] = `Bearer ${access_token}`
          state.$uid = uid
          state.$grp = grp
          const claims = decode_jwt (access_token)
          delete claims.uid
          delete claims.grp
          state.$claims = claims
          state.$ls.set ('access_token', access_token)
          if (!!refresh_token) {
            const refresh_token_timeout = decode_jwt (refresh_token).exp - new Date ().unixepoch ()
            state.$ls.set ('refresh_token', refresh_token, refresh_token_timeout)
          }
          state.$authentificated = true
          state.$has_credential = true
          frontend.setup_sentry ()
        },
        {% block vuex_mutations %}{% endblock %}
      },
      actions: {
        {% block vuex_actions %}{% endblock %}
      },
    })
    window.store = store
    </script>
  {% endblock vuex %}

  {% block vue_router %}
    {% if context.vue_config.use_router %}
      <script>
        const { useRouter, useRoute, useLink, RouterLink, onBeforeRouteLeave, onBeforeRouteUpdate } = VueRouter
        const router = VueRouter.createRouter ({
          history: VueRouter.createWebHistory ('{{ context.vue_config.use_router }}'),
          routes: [
            {% block vue_routes scoped %}
              {{ routes }}
            {% endblock %}
          ],
          {% block scroll_behavior %}
            scrollBehavior (to, from, savedPosition) {
              if (!savedPosition) {
                savedPosition = { left: 0, top: 0 }
              }
              return new Promise((resolve, reject) => {
                setTimeout(() => {
                  resolve (savedPosition)
                }, {{ context.vue_config.get ('scroll_delay', 400) }})
              })
            },
          {% endblock %}
        })

        {% block vue_router_before_each %}
          router.beforeEach ((to, from, next) => {
            next()
          })
        {% endblock %}

        {% block vue_router_after_each %}
          router.afterEach (async (to, from) => {
            store.state.$error_blocked = false
            frontend.gtag ('page_view')
          })
        {% endblock %}
        window.router = router
        frontend.log ("vue-router is ready", "debug")
      </script>
    {% else %}
      <script>
          const useRouter = null
      </script>
    {% endif %}
  {% endblock vue_router %}

  {% block vue %}
    <script>
    const {
      ref, reactive, computed, watch, watchEffect, getCurrentInstance, inject, provide, InjectionKey,
      nextTick, onBeforeMount, onMounted, onBeforeUpdate, onUpdated, onBeforeUnmount, onUnmounted,
      onErrorCaptured, onRenderTracked, onRenderTriggered, onActivated, onDeactivated,
      defineProps, defineEmits, defineExpose, defineModel
    } = Vue

    const useState = () => {
      const store = Vuex.useStore()
      return Object.fromEntries(Object.keys(store.state).map(key => [key, Vue.computed(() => store.state[key])]))
    }

    const useGetters = () => {
      const store = Vuex.useStore()
      return Object.fromEntries(Object.keys(store.getters).map(getter => [getter, Vue.computed(() => store.getters[getter])]))
    }

    const useMutations = () => {
      const store = Vuex.useStore()
      return Object.fromEntries(Object.keys(store._mutations).map(mutation => [mutation, value => store.commit(mutation, value)]))
    }

    const useActions = () => {
      const store = Vuex.useStore()
      return Object.fromEntries(Object.keys(store._actions).map(action => [action, value => store.dispatch(action, value)]))
    }

    {% if use_vue_loader %}
      const { loadModule } = window ['vue3-sfc-loader']
      const options = {
          moduleCache: {
            vue: Vue
          },

          async getFile (url) {
            const res = await fetch (url, {cache: "no-cache"})
            if ( !res.ok )
              throw Object.assign (new Error (res.statusText + ' ' + url), { res })
            return {
              getContentData: asBinary => asBinary ? res.arrayBuffer () : res.text (),
            }
          },

          addStyle (textContent) {
            const style = Object.assign (document.createElement('style'), { textContent })
            const ref = document.head.getElementsByTagName ('style') [0] || null
            document.head.insertBefore (style, ref)
          },
        }
        frontend.log ("vue-loader is ready", "debug")
    {% endif %}
    </script>

    <script>
    const app = Vue.createApp ({
      setup (props, context) {
        {% block vue_setup %}
          const { state } = useStore ()
          const show_debug_output = ref (false)
          function detect_screen (evt) {
            store.state.$breakpoint = frontend.device.breakpoint ()
          }
          onMounted (() => {
            detect_screen ()
            addEventListener ("resize", (event) => {detect_screen (event)})
          })

          {% set exporting = "show_debug_output" %}
          {% if context.vue_config.use_router %}
            const router = useRouter ()
            const route = useRoute ()
            {% set exporting = exporting + ", router, route" %}
          {% endif %}
          return { state, {{ exporting }} }
        {% endblock %}
      },
      data () {
        return {
          {% block vue_data %}{% endblock %}
        }
      },
      methods: {
        callFunction (f) {
          f ()
        },
        {% block vue_methods %}{% endblock %}
      },
      components: {
        {% block vue_components %}{% endblock %}
      },
      computed: {
        ...mapVuexItems (),
        {% block vue_computed %}{% endblock %}
      },
      watch: {
        {% block vue_watch %}{% endblock %}
      },

      beforeCreate () {
        {% block vue_before_create %}{% endblock %}
      },
      created () {
        {% block vue_created %}{% endblock %}
      },
      beforeMount () {
        _readSchemas ()
        {% block vue_before_mount %}{% endblock %}
      },
      mounted () {
        _readDataset ()
        if (this.$csrf) {
          axios.defaults.headers.common [this.$csrf.name] = this.$csrf.token
        }
        frontend.gtag ('page_view')
        {% block vue_mounted %}{% endblock %}
      },
      beforeUpdate () {
        {% block vue_before_update %}{% endblock %}
      },
      updated () {
        {% block vue_updated %}{% endblock %}
      },
      beforeDestroy () {
        {% block vue_before_destroy %}{% endblock %}
      },
      destroyed () {
        {% block vue_destroyed %}{% endblock %}
      },
    })

    {% if use_vue_loader %}
      {% if app.debug %}
        {{ global_component ('atila-vue/components/dev/vuex-state.vue') }}
      {% endif %}
      {% if router_view_layout %}
        {{ global_component (router_view_layout, 'app-layout') }}
      {% endif %}
      {% block global_component %}{% endblock %}
    {% endif %}
    </script>

    <script>
    const emitter = mitt()
    app.provide ('emitter', emitter)
    app.use (store)
    {% if context.vue_config.use_router %}
      app.use (router)
    {% endif %}

    {% block vue_app_created %}{% endblock %}

    app.config.errorHandler = (err, vm, info) => {
      frontend.error_captured (err, vm, info)
    }

    app.config.warnHandler = (msg, instance, trace) => {
      !IGNORABLE_VUE_WARNINGS.some((warning) => msg.includes(warning)) && console.warn('[warn:vue] '.concat(msg).concat(trace))
    }

    app.mount ('#app')
    window.app = app
    frontend.setup_sentry ()
    frontend.log ("vue app is mountable", "debug")
    </script>

  {% endblock vue %}

  {% block vue_preftech %}
    <script>
    {% for path in pathes %}
      prefetch ("{{ path }}")
    {% endfor %}
    </script>
  {% endblock vue_preftech %}

{% endblock body_trailer %}
